/* pager.c generated by valac 0.56.14, the Vala compiler
 * generated from pager.vala, do not modify */

/* pager.vala
 *
 * Copyright 2023 Rirusha
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <adwaita.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#define CASSETTE_PAGER_PAGES_DELIMETER "__PAGES_DELIMETER__"
#define CASSETTE_PAGER_PARTS_DELIMETER "__PART_DELIMETER__"
#define CASSETTE_PAGER_ARGS_DELIMETER "__ARGS_DELIMETER__"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CASSETTE_PAGES_TYPE_ONLINE,
	CASSETTE_PAGES_TYPE_LOCAL
} CassettePagesType;

#define CASSETTE_TYPE_PAGES_TYPE (cassette_pages_type_get_type ())

#define CASSETTE_TYPE_PAGE_INFO (cassette_page_info_get_type ())
typedef struct _CassettePageInfo CassettePageInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define CASSETTE_TYPE_BASE_VIEW (cassette_base_view_get_type ())
#define CASSETTE_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_BASE_VIEW, CassetteBaseView))
#define CASSETTE_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_BASE_VIEW, CassetteBaseViewClass))
#define CASSETTE_IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_BASE_VIEW))
#define CASSETTE_IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_BASE_VIEW))
#define CASSETTE_BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_BASE_VIEW, CassetteBaseViewClass))

typedef struct _CassetteBaseView CassetteBaseView;
typedef struct _CassetteBaseViewClass CassetteBaseViewClass;

#define CASSETTE_TYPE_HAS_TRACKS_VIEW (cassette_has_tracks_view_get_type ())
#define CASSETTE_HAS_TRACKS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_HAS_TRACKS_VIEW, CassetteHasTracksView))
#define CASSETTE_HAS_TRACKS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_HAS_TRACKS_VIEW, CassetteHasTracksViewClass))
#define CASSETTE_IS_HAS_TRACKS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_HAS_TRACKS_VIEW))
#define CASSETTE_IS_HAS_TRACKS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_HAS_TRACKS_VIEW))
#define CASSETTE_HAS_TRACKS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_HAS_TRACKS_VIEW, CassetteHasTracksViewClass))

typedef struct _CassetteHasTracksView CassetteHasTracksView;
typedef struct _CassetteHasTracksViewClass CassetteHasTracksViewClass;

#define CASSETTE_TYPE_CACHIABLE_VIEW (cassette_cachiable_view_get_type ())
#define CASSETTE_CACHIABLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_CACHIABLE_VIEW, CassetteCachiableView))
#define CASSETTE_CACHIABLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_CACHIABLE_VIEW, CassetteCachiableViewClass))
#define CASSETTE_IS_CACHIABLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_CACHIABLE_VIEW))
#define CASSETTE_IS_CACHIABLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_CACHIABLE_VIEW))
#define CASSETTE_CACHIABLE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_CACHIABLE_VIEW, CassetteCachiableViewClass))

typedef struct _CassetteCachiableView CassetteCachiableView;
typedef struct _CassetteCachiableViewClass CassetteCachiableViewClass;

#define CASSETTE_TYPE_PLAYLIST_VIEW (cassette_playlist_view_get_type ())
#define CASSETTE_PLAYLIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_PLAYLIST_VIEW, CassettePlaylistView))
#define CASSETTE_PLAYLIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_PLAYLIST_VIEW, CassettePlaylistViewClass))
#define CASSETTE_IS_PLAYLIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_PLAYLIST_VIEW))
#define CASSETTE_IS_PLAYLIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_PLAYLIST_VIEW))
#define CASSETTE_PLAYLIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_PLAYLIST_VIEW, CassettePlaylistViewClass))

typedef struct _CassettePlaylistView CassettePlaylistView;
typedef struct _CassettePlaylistViewClass CassettePlaylistViewClass;

#define CASSETTE_TYPE_PLAYLISTS_VIEW (cassette_playlists_view_get_type ())
#define CASSETTE_PLAYLISTS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_PLAYLISTS_VIEW, CassettePlaylistsView))
#define CASSETTE_PLAYLISTS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_PLAYLISTS_VIEW, CassettePlaylistsViewClass))
#define CASSETTE_IS_PLAYLISTS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_PLAYLISTS_VIEW))
#define CASSETTE_IS_PLAYLISTS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_PLAYLISTS_VIEW))
#define CASSETTE_PLAYLISTS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_PLAYLISTS_VIEW, CassettePlaylistsViewClass))

typedef struct _CassettePlaylistsView CassettePlaylistsView;
typedef struct _CassettePlaylistsViewClass CassettePlaylistsViewClass;

#define CASSETTE_TYPE_PAGER (cassette_pager_get_type ())
#define CASSETTE_PAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_PAGER, CassettePager))
#define CASSETTE_PAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_PAGER, CassettePagerClass))
#define CASSETTE_IS_PAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_PAGER))
#define CASSETTE_IS_PAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_PAGER))
#define CASSETTE_PAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_PAGER, CassettePagerClass))

typedef struct _CassettePager CassettePager;
typedef struct _CassettePagerClass CassettePagerClass;
typedef struct _CassettePagerPrivate CassettePagerPrivate;

#define CASSETTE_TYPE_MAIN_WINDOW (cassette_main_window_get_type ())
#define CASSETTE_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_MAIN_WINDOW, CassetteMainWindow))
#define CASSETTE_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_MAIN_WINDOW, CassetteMainWindowClass))
#define CASSETTE_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_MAIN_WINDOW))
#define CASSETTE_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_MAIN_WINDOW))
#define CASSETTE_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_MAIN_WINDOW, CassetteMainWindowClass))

typedef struct _CassetteMainWindow CassetteMainWindow;
typedef struct _CassetteMainWindowClass CassetteMainWindowClass;
enum  {
	CASSETTE_PAGER_0_PROPERTY,
	CASSETTE_PAGER_WINDOW_PROPERTY,
	CASSETTE_PAGER_STACK_PROPERTY,
	CASSETTE_PAGER_CUSTOM_PAGES_PROPERTY,
	CASSETTE_PAGER_NUM_PROPERTIES
};
static GParamSpec* cassette_pager_properties[CASSETTE_PAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE (cassette_abstract_loadable_page_get_type ())
#define CASSETTE_ABSTRACT_LOADABLE_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE, CassetteAbstractLoadablePage))
#define CASSETTE_ABSTRACT_LOADABLE_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE, CassetteAbstractLoadablePageClass))
#define CASSETTE_IS_ABSTRACT_LOADABLE_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE))
#define CASSETTE_IS_ABSTRACT_LOADABLE_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE))
#define CASSETTE_ABSTRACT_LOADABLE_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE, CassetteAbstractLoadablePageClass))

typedef struct _CassetteAbstractLoadablePage CassetteAbstractLoadablePage;
typedef struct _CassetteAbstractLoadablePageClass CassetteAbstractLoadablePageClass;

#define CASSETTE_TYPE_PAGE_ROOT (cassette_page_root_get_type ())
#define CASSETTE_PAGE_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_PAGE_ROOT, CassettePageRoot))
#define CASSETTE_PAGE_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_PAGE_ROOT, CassettePageRootClass))
#define CASSETTE_IS_PAGE_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_PAGE_ROOT))
#define CASSETTE_IS_PAGE_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_PAGE_ROOT))
#define CASSETTE_PAGE_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_PAGE_ROOT, CassettePageRootClass))

typedef struct _CassettePageRoot CassettePageRoot;
typedef struct _CassettePageRootClass CassettePageRootClass;
#define _cassette_page_info_free0(var) ((var == NULL) ? NULL : (var = (cassette_page_info_free (var), NULL)))

#define CASSETTE_CLIENT_CACHIER_TYPE_STORAGER (cassette_client_cachier_storager_get_type ())
#define CASSETTE_CLIENT_CACHIER_STORAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER, CassetteClientCachierStorager))
#define CASSETTE_CLIENT_CACHIER_STORAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER, CassetteClientCachierStoragerClass))
#define CASSETTE_CLIENT_CACHIER_IS_STORAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER))
#define CASSETTE_CLIENT_CACHIER_IS_STORAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER))
#define CASSETTE_CLIENT_CACHIER_STORAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER, CassetteClientCachierStoragerClass))

typedef struct _CassetteClientCachierStorager CassetteClientCachierStorager;
typedef struct _CassetteClientCachierStoragerClass CassetteClientCachierStoragerClass;

#define CASSETTE_TYPE_MAIN_VIEW (cassette_main_view_get_type ())
#define CASSETTE_MAIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_MAIN_VIEW, CassetteMainView))
#define CASSETTE_MAIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_MAIN_VIEW, CassetteMainViewClass))
#define CASSETTE_IS_MAIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_MAIN_VIEW))
#define CASSETTE_IS_MAIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_MAIN_VIEW))
#define CASSETTE_MAIN_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_MAIN_VIEW, CassetteMainViewClass))

typedef struct _CassetteMainView CassetteMainView;
typedef struct _CassetteMainViewClass CassetteMainViewClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _CassettePageInfo {
	gchar* id;
	gchar* title;
	gchar* icon_name;
	gchar* view_type_name;
	gchar** args;
	gint args_length1;
};

struct _CassettePager {
	GObject parent_instance;
	CassettePagerPrivate * priv;
};

struct _CassettePagerClass {
	GObjectClass parent_class;
};

struct _CassettePagerPrivate {
	CassetteMainWindow* _window;
	AdwViewStack* _stack;
	GeeArrayList* _custom_pages;
	GFile* pages_file;
};

static gint CassettePager_private_offset;
static gpointer cassette_pager_parent_class = NULL;
VALA_EXTERN CassetteClientCachierStorager* cassette_storager;

VALA_EXTERN GType cassette_pages_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType cassette_page_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CassettePageInfo* cassette_page_info_dup (const CassettePageInfo* self);
VALA_EXTERN void cassette_page_info_free (CassettePageInfo* self);
VALA_EXTERN void cassette_page_info_copy (const CassettePageInfo* self,
                              CassettePageInfo* dest);
VALA_EXTERN void cassette_page_info_destroy (CassettePageInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (CassettePageInfo, cassette_page_info_destroy)
VALA_EXTERN void cassette_page_info_from_string (const gchar* page_info_str,
                                     CassettePageInfo* result);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
VALA_EXTERN gchar* cassette_page_info_to_string (CassettePageInfo *self);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
VALA_EXTERN gchar** cassette_get_args_names (GType view_type,
                                 gint* result_length1);
VALA_EXTERN GType cassette_base_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteBaseView, g_object_unref)
VALA_EXTERN GType cassette_has_tracks_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteHasTracksView, g_object_unref)
VALA_EXTERN GType cassette_cachiable_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteCachiableView, g_object_unref)
VALA_EXTERN GType cassette_playlist_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassettePlaylistView, g_object_unref)
VALA_EXTERN GType cassette_playlists_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassettePlaylistsView, g_object_unref)
VALA_EXTERN GType cassette_pager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassettePager, g_object_unref)
VALA_EXTERN GType cassette_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteMainWindow, g_object_unref)
VALA_EXTERN CassettePager* cassette_pager_new (CassetteMainWindow* window,
                                   AdwViewStack* stack);
VALA_EXTERN CassettePager* cassette_pager_construct (GType object_type,
                                         CassetteMainWindow* window,
                                         AdwViewStack* stack);
static void cassette_pager_add_page (CassettePager* self,
                              CassettePageInfo* page_info);
static void _vala_GValue_array_free (GValue * array,
                              gssize array_length);
VALA_EXTERN GType cassette_abstract_loadable_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteAbstractLoadablePage, g_object_unref)
VALA_EXTERN GType cassette_page_root_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassettePageRoot, g_object_unref)
VALA_EXTERN CassetteMainWindow* cassette_pager_get_window (CassettePager* self);
VALA_EXTERN CassettePageRoot* cassette_page_root_new (CassetteMainWindow* window,
                                          CassetteBaseView* main_view);
VALA_EXTERN CassettePageRoot* cassette_page_root_construct (GType object_type,
                                                CassetteMainWindow* window,
                                                CassetteBaseView* main_view);
VALA_EXTERN AdwViewStack* cassette_pager_get_stack (CassettePager* self);
VALA_EXTERN void cassette_pager_update_page (CassettePager* self,
                                 const gchar* page_id,
                                 const gchar* new_page_title,
                                 const gchar* new_page_icon_name);
VALA_EXTERN void cassette_main_window_show_message (CassetteMainWindow* self,
                                        const gchar* message);
static void cassette_pager_save_pages (CassettePager* self);
VALA_EXTERN void cassette_pager_load_pages (CassettePager* self,
                                CassettePagesType* pages_type_if_failed);
VALA_EXTERN void cassette_pager_add_custom_page (CassettePager* self,
                                     CassettePageInfo* page_info);
static void cassette_pager_clear_pages (CassettePager* self);
VALA_EXTERN GType cassette_client_cachier_storager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientCachierStorager, g_object_unref)
VALA_EXTERN GSettings* cassette_client_cachier_storager_get_settings (CassetteClientCachierStorager* self);
static void cassette_pager_set_online_default_pages (CassettePager* self);
static void cassette_pager_set_local_default_pages (CassettePager* self);
static void cassette_pager_load_static_pages (CassettePager* self);
static void cassette_pager_load_custom_pages (CassettePager* self);
VALA_EXTERN GType cassette_main_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteMainView, g_object_unref)
VALA_EXTERN void cassette_client_logger_warning (const gchar* message);
static void cassette_pager_clear_static_page (CassettePager* self,
                                       const gchar* page_id);
static void cassette_pager_clear_page (CassettePager* self,
                                const gchar* page_id);
VALA_EXTERN void cassette_pager_remove_page (CassettePager* self,
                                 const gchar* page_id);
VALA_EXTERN void cassette_pager_set_window (CassettePager* self,
                                CassetteMainWindow* value);
VALA_EXTERN void cassette_pager_set_stack (CassettePager* self,
                               AdwViewStack* value);
VALA_EXTERN GeeArrayList* cassette_pager_get_custom_pages (CassettePager* self);
VALA_EXTERN void cassette_pager_set_custom_pages (CassettePager* self,
                                      GeeArrayList* value);
static GObject * cassette_pager_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
VALA_EXTERN GFile* cassette_client_cachier_storager_get_cache_dir_file (CassetteClientCachierStorager* self);
static void _cassette_pager___lambda219_ (CassettePager* self,
                                   const gchar* key);
static void __cassette_pager___lambda219__g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self);
static void cassette_pager_finalize (GObject * obj);
static GType cassette_pager_get_type_once (void);
static void _vala_cassette_pager_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_cassette_pager_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

 G_GNUC_NO_INLINE static GType
cassette_pages_type_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_PAGES_TYPE_ONLINE, "CASSETTE_PAGES_TYPE_ONLINE", "online"}, {CASSETTE_PAGES_TYPE_LOCAL, "CASSETTE_PAGES_TYPE_LOCAL", "local"}, {0, NULL, NULL}};
	GType cassette_pages_type_type_id;
	cassette_pages_type_type_id = g_enum_register_static ("CassettePagesType", values);
	return cassette_pages_type_type_id;
}

GType
cassette_pages_type_get_type (void)
{
	static gsize cassette_pages_type_type_id__once = 0;
	if (g_once_init_enter (&cassette_pages_type_type_id__once)) {
		GType cassette_pages_type_type_id;
		cassette_pages_type_type_id = cassette_pages_type_get_type_once ();
		g_once_init_leave (&cassette_pages_type_type_id__once, cassette_pages_type_type_id);
	}
	return cassette_pages_type_type_id__once;
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 54 "../src/pager.vala"
	if (length >= 0) {
#line 351 "pager.c"
		gchar** result;
		gssize i;
#line 54 "../src/pager.vala"
		result = g_new0 (gchar*, length + 1);
#line 54 "../src/pager.vala"
		for (i = 0; i < length; i++) {
#line 358 "pager.c"
			gchar* _tmp0_;
#line 54 "../src/pager.vala"
			_tmp0_ = g_strdup (self[i]);
#line 54 "../src/pager.vala"
			result[i] = _tmp0_;
#line 364 "pager.c"
		}
#line 54 "../src/pager.vala"
		return result;
#line 368 "pager.c"
	}
#line 54 "../src/pager.vala"
	return NULL;
#line 372 "pager.c"
}

void
cassette_page_info_from_string (const gchar* page_info_str,
                                CassettePageInfo* result)
{
	gchar** all = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint all_length1;
	gint _all_size_;
	gchar** all_args = NULL;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint all_args_length1;
	gint _all_args_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar** _tmp25_;
	gint _tmp25__length1;
	CassettePageInfo _tmp26_ = {0};
#line 44 "../src/pager.vala"
	g_return_if_fail (page_info_str != NULL);
#line 45 "../src/pager.vala"
	_tmp1_ = _tmp0_ = g_strsplit (page_info_str, CASSETTE_PAGER_PARTS_DELIMETER, 0);
#line 45 "../src/pager.vala"
	all = _tmp1_;
#line 45 "../src/pager.vala"
	all_length1 = _vala_array_length (_tmp0_);
#line 45 "../src/pager.vala"
	_all_size_ = all_length1;
#line 47 "../src/pager.vala"
	_tmp2_ = all;
#line 47 "../src/pager.vala"
	_tmp2__length1 = all_length1;
#line 47 "../src/pager.vala"
	_tmp3_ = _tmp2_[4];
#line 47 "../src/pager.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, CASSETTE_PAGER_ARGS_DELIMETER, 0);
#line 47 "../src/pager.vala"
	all_args = _tmp5_;
#line 47 "../src/pager.vala"
	all_args_length1 = _vala_array_length (_tmp4_);
#line 47 "../src/pager.vala"
	_all_args_size_ = all_args_length1;
#line 437 "pager.c"
	{
		gint i = 0;
#line 48 "../src/pager.vala"
		i = 0;
#line 442 "pager.c"
		{
			gboolean _tmp6_ = FALSE;
#line 48 "../src/pager.vala"
			_tmp6_ = TRUE;
#line 48 "../src/pager.vala"
			while (TRUE) {
#line 449 "pager.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
#line 48 "../src/pager.vala"
				if (!_tmp6_) {
#line 457 "pager.c"
					gint _tmp7_;
#line 48 "../src/pager.vala"
					_tmp7_ = i;
#line 48 "../src/pager.vala"
					i = _tmp7_ + 1;
#line 463 "pager.c"
				}
#line 48 "../src/pager.vala"
				_tmp6_ = FALSE;
#line 48 "../src/pager.vala"
				_tmp8_ = all_args;
#line 48 "../src/pager.vala"
				_tmp8__length1 = all_args_length1;
#line 48 "../src/pager.vala"
				if (!(i < _tmp8__length1)) {
#line 48 "../src/pager.vala"
					break;
#line 475 "pager.c"
				}
#line 49 "../src/pager.vala"
				_tmp9_ = all_args;
#line 49 "../src/pager.vala"
				_tmp9__length1 = all_args_length1;
#line 49 "../src/pager.vala"
				_tmp10_ = _tmp9_[i];
#line 49 "../src/pager.vala"
				if (g_strcmp0 (_tmp10_, "") == 0) {
#line 485 "pager.c"
					gchar** _tmp11_;
					gint _tmp11__length1;
#line 50 "../src/pager.vala"
					_tmp11_ = all_args;
#line 50 "../src/pager.vala"
					_tmp11__length1 = all_args_length1;
#line 50 "../src/pager.vala"
					_g_free0 (_tmp11_[i]);
#line 50 "../src/pager.vala"
					_tmp11_[i] = NULL;
#line 496 "pager.c"
				}
			}
		}
	}
#line 54 "../src/pager.vala"
	_tmp12_ = all;
#line 54 "../src/pager.vala"
	_tmp12__length1 = all_length1;
#line 54 "../src/pager.vala"
	_tmp13_ = _tmp12_[0];
#line 54 "../src/pager.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 54 "../src/pager.vala"
	_tmp15_ = all;
#line 54 "../src/pager.vala"
	_tmp15__length1 = all_length1;
#line 54 "../src/pager.vala"
	_tmp16_ = _tmp15_[1];
#line 54 "../src/pager.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 54 "../src/pager.vala"
	_tmp18_ = all;
#line 54 "../src/pager.vala"
	_tmp18__length1 = all_length1;
#line 54 "../src/pager.vala"
	_tmp19_ = _tmp18_[2];
#line 54 "../src/pager.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 54 "../src/pager.vala"
	_tmp21_ = all;
#line 54 "../src/pager.vala"
	_tmp21__length1 = all_length1;
#line 54 "../src/pager.vala"
	_tmp22_ = _tmp21_[3];
#line 54 "../src/pager.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 54 "../src/pager.vala"
	_tmp24_ = all_args;
#line 54 "../src/pager.vala"
	_tmp24__length1 = all_args_length1;
#line 54 "../src/pager.vala"
	_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup6 (_tmp24_, _tmp24__length1) : _tmp24_;
#line 54 "../src/pager.vala"
	_tmp25__length1 = _tmp24__length1;
#line 54 "../src/pager.vala"
	_g_free0 (_tmp26_.id);
#line 54 "../src/pager.vala"
	_tmp26_.id = _tmp14_;
#line 54 "../src/pager.vala"
	_g_free0 (_tmp26_.title);
#line 54 "../src/pager.vala"
	_tmp26_.title = _tmp17_;
#line 54 "../src/pager.vala"
	_g_free0 (_tmp26_.icon_name);
#line 54 "../src/pager.vala"
	_tmp26_.icon_name = _tmp20_;
#line 54 "../src/pager.vala"
	_g_free0 (_tmp26_.view_type_name);
#line 54 "../src/pager.vala"
	_tmp26_.view_type_name = _tmp23_;
#line 54 "../src/pager.vala"
	_tmp26_.args = (_vala_array_free (_tmp26_.args, _tmp26_.args_length1, (GDestroyNotify) g_free), NULL);
#line 54 "../src/pager.vala"
	_tmp26_.args = _tmp25_;
#line 54 "../src/pager.vala"
	_tmp26_.args_length1 = _tmp25__length1;
#line 54 "../src/pager.vala"
	*result = _tmp26_;
#line 54 "../src/pager.vala"
	all_args = (_vala_array_free (all_args, all_args_length1, (GDestroyNotify) g_free), NULL);
#line 54 "../src/pager.vala"
	all = (_vala_array_free (all, all_length1, (GDestroyNotify) g_free), NULL);
#line 54 "../src/pager.vala"
	return;
#line 571 "pager.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 585 "pager.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 589 "pager.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 595 "pager.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 600 "pager.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 606 "pager.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 610 "pager.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 614 "pager.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 618 "pager.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 622 "pager.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 626 "pager.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 641 "pager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 650 "pager.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 657 "pager.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 663 "pager.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 671 "pager.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 675 "pager.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 681 "pager.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 686 "pager.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 692 "pager.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 696 "pager.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 700 "pager.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 706 "pager.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 712 "pager.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 724 "pager.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 728 "pager.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 732 "pager.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 737 "pager.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 745 "pager.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 763 "pager.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 769 "pager.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 773 "pager.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 781 "pager.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 790 "pager.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 799 "pager.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 805 "pager.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 813 "pager.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 825 "pager.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 831 "pager.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 835 "pager.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 843 "pager.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 854 "pager.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 863 "pager.c"
	}
}

gchar*
cassette_page_info_to_string (CassettePageInfo *self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 64 "../src/pager.vala"
	_tmp0_ = (*self).id;
#line 64 "../src/pager.vala"
	_tmp1_ = g_strconcat (_tmp0_, CASSETTE_PAGER_PARTS_DELIMETER, NULL);
#line 64 "../src/pager.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/pager.vala"
	_tmp3_ = (*self).title;
#line 64 "../src/pager.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 64 "../src/pager.vala"
	_tmp5_ = _tmp4_;
#line 64 "../src/pager.vala"
	_tmp6_ = g_strconcat (_tmp5_, CASSETTE_PAGER_PARTS_DELIMETER, NULL);
#line 64 "../src/pager.vala"
	_tmp7_ = _tmp6_;
#line 64 "../src/pager.vala"
	_tmp8_ = (*self).icon_name;
#line 64 "../src/pager.vala"
	_tmp9_ = g_strconcat (_tmp7_, _tmp8_, NULL);
#line 64 "../src/pager.vala"
	_tmp10_ = _tmp9_;
#line 64 "../src/pager.vala"
	_tmp11_ = g_strconcat (_tmp10_, CASSETTE_PAGER_PARTS_DELIMETER, NULL);
#line 64 "../src/pager.vala"
	_tmp12_ = _tmp11_;
#line 64 "../src/pager.vala"
	_tmp13_ = (*self).view_type_name;
#line 64 "../src/pager.vala"
	_tmp14_ = g_strconcat (_tmp12_, _tmp13_, NULL);
#line 64 "../src/pager.vala"
	_tmp15_ = _tmp14_;
#line 64 "../src/pager.vala"
	_tmp16_ = g_strconcat (_tmp15_, CASSETTE_PAGER_PARTS_DELIMETER, NULL);
#line 64 "../src/pager.vala"
	_tmp17_ = _tmp16_;
#line 64 "../src/pager.vala"
	_tmp18_ = (*self).args;
#line 64 "../src/pager.vala"
	_tmp18__length1 = (*self).args_length1;
#line 64 "../src/pager.vala"
	_tmp19_ = _vala_g_strjoinv (CASSETTE_PAGER_ARGS_DELIMETER, _tmp18_, (gint) _tmp18__length1);
#line 64 "../src/pager.vala"
	_tmp20_ = _tmp19_;
#line 64 "../src/pager.vala"
	_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 64 "../src/pager.vala"
	_tmp22_ = _tmp21_;
#line 64 "../src/pager.vala"
	_g_free0 (_tmp20_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp17_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp15_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp12_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp10_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp7_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp5_);
#line 64 "../src/pager.vala"
	_g_free0 (_tmp2_);
#line 64 "../src/pager.vala"
	result = _tmp22_;
#line 64 "../src/pager.vala"
	return result;
#line 963 "pager.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 37 "../src/pager.vala"
	if (length >= 0) {
#line 972 "pager.c"
		gchar** result;
		gssize i;
#line 37 "../src/pager.vala"
		result = g_new0 (gchar*, length + 1);
#line 37 "../src/pager.vala"
		for (i = 0; i < length; i++) {
#line 979 "pager.c"
			gchar* _tmp0_;
#line 37 "../src/pager.vala"
			_tmp0_ = g_strdup (self[i]);
#line 37 "../src/pager.vala"
			result[i] = _tmp0_;
#line 985 "pager.c"
		}
#line 37 "../src/pager.vala"
		return result;
#line 989 "pager.c"
	}
#line 37 "../src/pager.vala"
	return NULL;
#line 993 "pager.c"
}

void
cassette_page_info_copy (const CassettePageInfo* self,
                         CassettePageInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
#line 37 "../src/pager.vala"
	_tmp0_ = (*self).id;
#line 37 "../src/pager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 37 "../src/pager.vala"
	_g_free0 ((*dest).id);
#line 37 "../src/pager.vala"
	(*dest).id = _tmp1_;
#line 37 "../src/pager.vala"
	_tmp2_ = (*self).title;
#line 37 "../src/pager.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 37 "../src/pager.vala"
	_g_free0 ((*dest).title);
#line 37 "../src/pager.vala"
	(*dest).title = _tmp3_;
#line 37 "../src/pager.vala"
	_tmp4_ = (*self).icon_name;
#line 37 "../src/pager.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 37 "../src/pager.vala"
	_g_free0 ((*dest).icon_name);
#line 37 "../src/pager.vala"
	(*dest).icon_name = _tmp5_;
#line 37 "../src/pager.vala"
	_tmp6_ = (*self).view_type_name;
#line 37 "../src/pager.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 37 "../src/pager.vala"
	_g_free0 ((*dest).view_type_name);
#line 37 "../src/pager.vala"
	(*dest).view_type_name = _tmp7_;
#line 37 "../src/pager.vala"
	_tmp8_ = (*self).args;
#line 37 "../src/pager.vala"
	_tmp8__length1 = (*self).args_length1;
#line 37 "../src/pager.vala"
	_tmp9_ = (_tmp8_ != NULL) ? _vala_array_dup7 (_tmp8_, _tmp8__length1) : _tmp8_;
#line 37 "../src/pager.vala"
	_tmp9__length1 = _tmp8__length1;
#line 37 "../src/pager.vala"
	(*dest).args = (_vala_array_free ((*dest).args, (*dest).args_length1, (GDestroyNotify) g_free), NULL);
#line 37 "../src/pager.vala"
	(*dest).args = _tmp9_;
#line 37 "../src/pager.vala"
	(*dest).args_length1 = _tmp9__length1;
#line 1058 "pager.c"
}

void
cassette_page_info_destroy (CassettePageInfo* self)
{
#line 38 "../src/pager.vala"
	_g_free0 ((*self).id);
#line 39 "../src/pager.vala"
	_g_free0 ((*self).title);
#line 40 "../src/pager.vala"
	_g_free0 ((*self).icon_name);
#line 41 "../src/pager.vala"
	_g_free0 ((*self).view_type_name);
#line 42 "../src/pager.vala"
	(*self).args = (_vala_array_free ((*self).args, (*self).args_length1, (GDestroyNotify) g_free), NULL);
#line 1074 "pager.c"
}

CassettePageInfo*
cassette_page_info_dup (const CassettePageInfo* self)
{
	CassettePageInfo* dup;
#line 37 "../src/pager.vala"
	dup = g_new0 (CassettePageInfo, 1);
#line 37 "../src/pager.vala"
	cassette_page_info_copy (self, dup);
#line 37 "../src/pager.vala"
	return dup;
#line 1087 "pager.c"
}

void
cassette_page_info_free (CassettePageInfo* self)
{
#line 37 "../src/pager.vala"
	cassette_page_info_destroy (self);
#line 37 "../src/pager.vala"
	g_free (self);
#line 1097 "pager.c"
}

 G_GNUC_NO_INLINE static GType
cassette_page_info_get_type_once (void)
{
	GType cassette_page_info_type_id;
	cassette_page_info_type_id = g_boxed_type_register_static ("CassettePageInfo", (GBoxedCopyFunc) cassette_page_info_dup, (GBoxedFreeFunc) cassette_page_info_free);
	return cassette_page_info_type_id;
}

GType
cassette_page_info_get_type (void)
{
	static gsize cassette_page_info_type_id__once = 0;
	if (g_once_init_enter (&cassette_page_info_type_id__once)) {
		GType cassette_page_info_type_id;
		cassette_page_info_type_id = cassette_page_info_get_type_once ();
		g_once_init_leave (&cassette_page_info_type_id__once, cassette_page_info_type_id);
	}
	return cassette_page_info_type_id__once;
}

gchar**
cassette_get_args_names (GType view_type,
                         gint* result_length1)
{
	gchar** result;
#line 73 "../src/pager.vala"
	if (view_type == CASSETTE_TYPE_PLAYLIST_VIEW) {
#line 1127 "pager.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 74 "../src/pager.vala"
		_tmp0_ = g_strdup ("uid");
#line 74 "../src/pager.vala"
		_tmp1_ = g_strdup ("kind");
#line 74 "../src/pager.vala"
		_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 74 "../src/pager.vala"
		_tmp2_[0] = _tmp0_;
#line 74 "../src/pager.vala"
		_tmp2_[1] = _tmp1_;
#line 74 "../src/pager.vala"
		_tmp3_ = _tmp2_;
#line 74 "../src/pager.vala"
		_tmp3__length1 = 2;
#line 74 "../src/pager.vala"
		if (result_length1) {
#line 74 "../src/pager.vala"
			*result_length1 = _tmp3__length1;
#line 1151 "pager.c"
		}
#line 74 "../src/pager.vala"
		result = _tmp3_;
#line 74 "../src/pager.vala"
		return result;
#line 1157 "pager.c"
	} else {
#line 75 "../src/pager.vala"
		if (view_type == CASSETTE_TYPE_PLAYLISTS_VIEW) {
#line 1161 "pager.c"
			gchar* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gint _tmp6__length1;
#line 76 "../src/pager.vala"
			_tmp4_ = g_strdup ("uid");
#line 76 "../src/pager.vala"
			_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 76 "../src/pager.vala"
			_tmp5_[0] = _tmp4_;
#line 76 "../src/pager.vala"
			_tmp6_ = _tmp5_;
#line 76 "../src/pager.vala"
			_tmp6__length1 = 1;
#line 76 "../src/pager.vala"
			if (result_length1) {
#line 76 "../src/pager.vala"
				*result_length1 = _tmp6__length1;
#line 1180 "pager.c"
			}
#line 76 "../src/pager.vala"
			result = _tmp6_;
#line 76 "../src/pager.vala"
			return result;
#line 1186 "pager.c"
		} else {
			const gchar* _tmp7_;
#line 78 "../src/pager.vala"
			_tmp7_ = g_type_name (view_type);
#line 78 "../src/pager.vala"
			g_message ("pager.vala:78: %s", _tmp7_);
#line 79 "../src/pager.vala"
			g_assert_not_reached ();
#line 1195 "pager.c"
		}
	}
}

static inline gpointer
cassette_pager_get_instance_private (CassettePager* self)
{
	return G_STRUCT_MEMBER_P (self, CassettePager_private_offset);
}

CassettePager*
cassette_pager_construct (GType object_type,
                          CassetteMainWindow* window,
                          AdwViewStack* stack)
{
	CassettePager * self = NULL;
#line 103 "../src/pager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 103 "../src/pager.vala"
	g_return_val_if_fail (stack != NULL, NULL);
#line 104 "../src/pager.vala"
	self = (CassettePager*) g_object_new (object_type, "window", window, "stack", stack, NULL);
#line 103 "../src/pager.vala"
	return self;
#line 1220 "pager.c"
}

CassettePager*
cassette_pager_new (CassetteMainWindow* window,
                    AdwViewStack* stack)
{
#line 103 "../src/pager.vala"
	return cassette_pager_construct (CASSETTE_TYPE_PAGER, window, stack);
#line 1229 "pager.c"
}

static void
_vala_GValue_array_free (GValue * array,
                         gssize array_length)
{
#line 142 "../src/pager.vala"
	if (array != NULL) {
#line 1238 "pager.c"
		gssize i;
#line 142 "../src/pager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 142 "../src/pager.vala"
			g_value_unset (&array[i]);
#line 1244 "pager.c"
		}
	}
#line 142 "../src/pager.vala"
	g_free (array);
#line 1249 "pager.c"
}

static void
cassette_pager_add_page (CassettePager* self,
                         CassettePageInfo* page_info)
{
	GType view_type = 0UL;
	CassettePageInfo _tmp0_;
	const gchar* _tmp1_;
	CassetteBaseView* view = NULL;
	CassettePageInfo _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	CassettePageRoot* ready_view = NULL;
	CassetteMainWindow* _tmp23_;
	CassetteBaseView* _tmp24_;
	CassettePageRoot* _tmp25_;
	AdwViewStack* _tmp26_;
	CassettePageInfo _tmp27_;
	const gchar* _tmp28_;
	CassettePageInfo _tmp29_;
	const gchar* _tmp30_;
	CassettePageInfo _tmp31_;
	const gchar* _tmp32_;
#line 129 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/pager.vala"
	g_return_if_fail (page_info != NULL);
#line 130 "../src/pager.vala"
	_tmp0_ = *page_info;
#line 130 "../src/pager.vala"
	_tmp1_ = _tmp0_.view_type_name;
#line 130 "../src/pager.vala"
	view_type = g_type_from_name (_tmp1_);
#line 133 "../src/pager.vala"
	_tmp2_ = *page_info;
#line 133 "../src/pager.vala"
	_tmp3_ = _tmp2_.args;
#line 133 "../src/pager.vala"
	_tmp3__length1 = _tmp2_.args_length1;
#line 134 "../src/pager.vala"
	if (_tmp3__length1 == 0) {
#line 1292 "pager.c"
		GObject* _tmp4_;
		GObject* _tmp5_;
#line 134 "../src/pager.vala"
		_tmp4_ = g_object_new (view_type, NULL);
#line 134 "../src/pager.vala"
		_tmp5_ = G_IS_INITIALLY_UNOWNED (_tmp4_) ? g_object_ref_sink (_tmp4_) : _tmp4_;
#line 134 "../src/pager.vala"
		_g_object_unref0 (view);
#line 134 "../src/pager.vala"
		view = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CASSETTE_TYPE_BASE_VIEW, CassetteBaseView);
#line 1303 "pager.c"
	} else {
		GValue* vals = NULL;
		CassettePageInfo _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		GValue* _tmp8_;
		gint vals_length1;
		gint _vals_size_;
		gint _tmp17_ = 0;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		GValue* _tmp20_;
		gint _tmp20__length1;
		GObject* _tmp21_;
		GObject* _tmp22_;
#line 136 "../src/pager.vala"
		_tmp6_ = *page_info;
#line 136 "../src/pager.vala"
		_tmp7_ = _tmp6_.args;
#line 136 "../src/pager.vala"
		_tmp7__length1 = _tmp6_.args_length1;
#line 136 "../src/pager.vala"
		_tmp8_ = g_new0 (GValue, _tmp7__length1);
#line 136 "../src/pager.vala"
		vals = _tmp8_;
#line 136 "../src/pager.vala"
		vals_length1 = _tmp7__length1;
#line 136 "../src/pager.vala"
		_vals_size_ = vals_length1;
#line 1334 "pager.c"
		{
			gint i = 0;
#line 138 "../src/pager.vala"
			i = 0;
#line 1339 "pager.c"
			{
				gboolean _tmp9_ = FALSE;
#line 138 "../src/pager.vala"
				_tmp9_ = TRUE;
#line 138 "../src/pager.vala"
				while (TRUE) {
#line 1346 "pager.c"
					GValue* _tmp11_;
					gint _tmp11__length1;
					GValue* _tmp12_;
					gint _tmp12__length1;
					CassettePageInfo _tmp13_;
					gchar** _tmp14_;
					gint _tmp14__length1;
					const gchar* _tmp15_;
					GValue _tmp16_ = {0};
#line 138 "../src/pager.vala"
					if (!_tmp9_) {
#line 1358 "pager.c"
						gint _tmp10_;
#line 138 "../src/pager.vala"
						_tmp10_ = i;
#line 138 "../src/pager.vala"
						i = _tmp10_ + 1;
#line 1364 "pager.c"
					}
#line 138 "../src/pager.vala"
					_tmp9_ = FALSE;
#line 138 "../src/pager.vala"
					_tmp11_ = vals;
#line 138 "../src/pager.vala"
					_tmp11__length1 = vals_length1;
#line 138 "../src/pager.vala"
					if (!(i < _tmp11__length1)) {
#line 138 "../src/pager.vala"
						break;
#line 1376 "pager.c"
					}
#line 139 "../src/pager.vala"
					_tmp12_ = vals;
#line 139 "../src/pager.vala"
					_tmp12__length1 = vals_length1;
#line 139 "../src/pager.vala"
					_tmp13_ = *page_info;
#line 139 "../src/pager.vala"
					_tmp14_ = _tmp13_.args;
#line 139 "../src/pager.vala"
					_tmp14__length1 = _tmp13_.args_length1;
#line 139 "../src/pager.vala"
					_tmp15_ = _tmp14_[i];
#line 139 "../src/pager.vala"
					g_value_init (&_tmp16_, G_TYPE_STRING);
#line 139 "../src/pager.vala"
					g_value_set_string (&_tmp16_, _tmp15_);
#line 139 "../src/pager.vala"
					G_IS_VALUE (&_tmp12_[i]) ? (g_value_unset (&_tmp12_[i]), NULL) : NULL;
#line 139 "../src/pager.vala"
					_tmp12_[i] = _tmp16_;
#line 1398 "pager.c"
				}
			}
		}
#line 142 "../src/pager.vala"
		_tmp18_ = cassette_get_args_names (view_type, &_tmp17_);
#line 142 "../src/pager.vala"
		_tmp19_ = _tmp18_;
#line 142 "../src/pager.vala"
		_tmp19__length1 = _tmp17_;
#line 142 "../src/pager.vala"
		_tmp20_ = vals;
#line 142 "../src/pager.vala"
		_tmp20__length1 = vals_length1;
#line 142 "../src/pager.vala"
		_tmp21_ = g_object_new_with_properties (view_type, (guint) _tmp20__length1, _tmp19_, _tmp20_);
#line 142 "../src/pager.vala"
		_tmp22_ = G_IS_INITIALLY_UNOWNED (_tmp21_) ? g_object_ref_sink (_tmp21_) : _tmp21_;
#line 142 "../src/pager.vala"
		_g_object_unref0 (view);
#line 142 "../src/pager.vala"
		view = G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, CASSETTE_TYPE_BASE_VIEW, CassetteBaseView);
#line 142 "../src/pager.vala"
		_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 142 "../src/pager.vala"
		vals = (_vala_GValue_array_free (vals, vals_length1), NULL);
#line 1424 "pager.c"
	}
#line 145 "../src/pager.vala"
	_tmp23_ = self->priv->_window;
#line 145 "../src/pager.vala"
	_tmp24_ = view;
#line 145 "../src/pager.vala"
	_tmp25_ = cassette_page_root_new (_tmp23_, _tmp24_);
#line 145 "../src/pager.vala"
	g_object_ref_sink (_tmp25_);
#line 145 "../src/pager.vala"
	ready_view = _tmp25_;
#line 147 "../src/pager.vala"
	_tmp26_ = self->priv->_stack;
#line 147 "../src/pager.vala"
	_tmp27_ = *page_info;
#line 147 "../src/pager.vala"
	_tmp28_ = _tmp27_.id;
#line 147 "../src/pager.vala"
	_tmp29_ = *page_info;
#line 147 "../src/pager.vala"
	_tmp30_ = _tmp29_.title;
#line 147 "../src/pager.vala"
	_tmp31_ = *page_info;
#line 147 "../src/pager.vala"
	_tmp32_ = _tmp31_.icon_name;
#line 147 "../src/pager.vala"
	adw_view_stack_add_titled_with_icon (_tmp26_, (GtkWidget*) ready_view, _tmp28_, _tmp30_, _tmp32_);
#line 134 "../src/pager.vala"
	_g_object_unref0 (ready_view);
#line 134 "../src/pager.vala"
	_g_object_unref0 (view);
#line 1456 "pager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 1475 "pager.c"
}

void
cassette_pager_update_page (CassettePager* self,
                            const gchar* page_id,
                            const gchar* new_page_title,
                            const gchar* new_page_icon_name)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 155 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/pager.vala"
	g_return_if_fail (page_id != NULL);
#line 157 "../src/pager.vala"
	if (new_page_title != NULL) {
#line 1492 "pager.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
#line 159 "../src/pager.vala"
		if (string_contains (new_page_title, CASSETTE_PAGER_ARGS_DELIMETER)) {
#line 159 "../src/pager.vala"
			_tmp2_ = TRUE;
#line 1499 "pager.c"
		} else {
#line 160 "../src/pager.vala"
			_tmp2_ = string_contains (new_page_title, CASSETTE_PAGER_PARTS_DELIMETER);
#line 1503 "pager.c"
		}
#line 158 "../src/pager.vala"
		if (_tmp2_) {
#line 159 "../src/pager.vala"
			_tmp1_ = TRUE;
#line 1509 "pager.c"
		} else {
#line 161 "../src/pager.vala"
			_tmp1_ = string_contains (new_page_title, CASSETTE_PAGER_PAGES_DELIMETER);
#line 1513 "pager.c"
		}
#line 158 "../src/pager.vala"
		_tmp0_ = _tmp1_;
#line 1517 "pager.c"
	} else {
#line 157 "../src/pager.vala"
		_tmp0_ = FALSE;
#line 1521 "pager.c"
	}
#line 156 "../src/pager.vala"
	if (_tmp0_) {
#line 1525 "pager.c"
		CassetteMainWindow* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 164 "../src/pager.vala"
		_tmp3_ = self->priv->_window;
#line 164 "../src/pager.vala"
		_tmp4_ = g_strdup_printf (_ ("Can't set title \"%s\" to page"), new_page_title);
#line 164 "../src/pager.vala"
		_tmp5_ = _tmp4_;
#line 164 "../src/pager.vala"
		cassette_main_window_show_message (_tmp3_, _tmp5_);
#line 164 "../src/pager.vala"
		_g_free0 (_tmp5_);
#line 165 "../src/pager.vala"
		return;
#line 1541 "pager.c"
	}
#line 168 "../src/pager.vala"
	if (new_page_icon_name != NULL) {
#line 1545 "pager.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 170 "../src/pager.vala"
		if (string_contains (new_page_icon_name, CASSETTE_PAGER_ARGS_DELIMETER)) {
#line 170 "../src/pager.vala"
			_tmp8_ = TRUE;
#line 1552 "pager.c"
		} else {
#line 171 "../src/pager.vala"
			_tmp8_ = string_contains (new_page_icon_name, CASSETTE_PAGER_PARTS_DELIMETER);
#line 1556 "pager.c"
		}
#line 169 "../src/pager.vala"
		if (_tmp8_) {
#line 170 "../src/pager.vala"
			_tmp7_ = TRUE;
#line 1562 "pager.c"
		} else {
#line 172 "../src/pager.vala"
			_tmp7_ = string_contains (new_page_icon_name, CASSETTE_PAGER_PAGES_DELIMETER);
#line 1566 "pager.c"
		}
#line 169 "../src/pager.vala"
		_tmp6_ = _tmp7_;
#line 1570 "pager.c"
	} else {
#line 168 "../src/pager.vala"
		_tmp6_ = FALSE;
#line 1574 "pager.c"
	}
#line 167 "../src/pager.vala"
	if (_tmp6_) {
#line 1578 "pager.c"
		CassetteMainWindow* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 175 "../src/pager.vala"
		_tmp9_ = self->priv->_window;
#line 175 "../src/pager.vala"
		_tmp10_ = g_strdup_printf (_ ("Can't set icon with name \"%s\" to page"), new_page_icon_name);
#line 175 "../src/pager.vala"
		_tmp11_ = _tmp10_;
#line 175 "../src/pager.vala"
		cassette_main_window_show_message (_tmp9_, _tmp11_);
#line 175 "../src/pager.vala"
		_g_free0 (_tmp11_);
#line 176 "../src/pager.vala"
		return;
#line 1594 "pager.c"
	}
	{
		gint i = 0;
#line 179 "../src/pager.vala"
		i = 0;
#line 1600 "pager.c"
		{
			gboolean _tmp12_ = FALSE;
#line 179 "../src/pager.vala"
			_tmp12_ = TRUE;
#line 179 "../src/pager.vala"
			while (TRUE) {
#line 1607 "pager.c"
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				GeeArrayList* _tmp17_;
				gpointer _tmp18_;
				CassettePageInfo* _tmp19_;
				const gchar* _tmp20_;
				gboolean _tmp21_;
#line 179 "../src/pager.vala"
				if (!_tmp12_) {
#line 1618 "pager.c"
					gint _tmp13_;
#line 179 "../src/pager.vala"
					_tmp13_ = i;
#line 179 "../src/pager.vala"
					i = _tmp13_ + 1;
#line 1624 "pager.c"
				}
#line 179 "../src/pager.vala"
				_tmp12_ = FALSE;
#line 179 "../src/pager.vala"
				_tmp14_ = self->priv->_custom_pages;
#line 179 "../src/pager.vala"
				_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 179 "../src/pager.vala"
				_tmp16_ = _tmp15_;
#line 179 "../src/pager.vala"
				if (!(i < _tmp16_)) {
#line 179 "../src/pager.vala"
					break;
#line 1638 "pager.c"
				}
#line 180 "../src/pager.vala"
				_tmp17_ = self->priv->_custom_pages;
#line 180 "../src/pager.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, i);
#line 180 "../src/pager.vala"
				_tmp19_ = (CassettePageInfo*) _tmp18_;
#line 180 "../src/pager.vala"
				_tmp20_ = (*_tmp19_).id;
#line 180 "../src/pager.vala"
				_tmp21_ = g_strcmp0 (_tmp20_, page_id) == 0;
#line 180 "../src/pager.vala"
				_cassette_page_info_free0 (_tmp19_);
#line 180 "../src/pager.vala"
				if (_tmp21_) {
#line 1654 "pager.c"
					CassettePageInfo* page_info = NULL;
					GeeArrayList* _tmp22_;
					gpointer _tmp23_;
					GeeArrayList* _tmp28_;
					CassettePageInfo* _tmp29_;
#line 181 "../src/pager.vala"
					_tmp22_ = self->priv->_custom_pages;
#line 181 "../src/pager.vala"
					_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, i);
#line 181 "../src/pager.vala"
					page_info = (CassettePageInfo*) _tmp23_;
#line 183 "../src/pager.vala"
					if (new_page_title != NULL) {
#line 1668 "pager.c"
						CassettePageInfo* _tmp24_;
						gchar* _tmp25_;
#line 184 "../src/pager.vala"
						_tmp24_ = page_info;
#line 184 "../src/pager.vala"
						_tmp25_ = g_strdup (new_page_title);
#line 184 "../src/pager.vala"
						_g_free0 ((*_tmp24_).title);
#line 184 "../src/pager.vala"
						(*_tmp24_).title = _tmp25_;
#line 1679 "pager.c"
					}
#line 186 "../src/pager.vala"
					if (new_page_title != NULL) {
#line 1683 "pager.c"
						CassettePageInfo* _tmp26_;
						gchar* _tmp27_;
#line 187 "../src/pager.vala"
						_tmp26_ = page_info;
#line 187 "../src/pager.vala"
						_tmp27_ = g_strdup (new_page_icon_name);
#line 187 "../src/pager.vala"
						_g_free0 ((*_tmp26_).icon_name);
#line 187 "../src/pager.vala"
						(*_tmp26_).icon_name = _tmp27_;
#line 1694 "pager.c"
					}
#line 190 "../src/pager.vala"
					_tmp28_ = self->priv->_custom_pages;
#line 190 "../src/pager.vala"
					_tmp29_ = page_info;
#line 190 "../src/pager.vala"
					gee_abstract_list_set ((GeeAbstractList*) _tmp28_, i, _tmp29_);
#line 191 "../src/pager.vala"
					_cassette_page_info_free0 (page_info);
#line 191 "../src/pager.vala"
					break;
#line 1706 "pager.c"
				}
			}
		}
	}
#line 195 "../src/pager.vala"
	cassette_pager_save_pages (self);
#line 196 "../src/pager.vala"
	cassette_pager_load_pages (self, NULL);
#line 1715 "pager.c"
}

void
cassette_pager_add_custom_page (CassettePager* self,
                                CassettePageInfo* page_info)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	CassettePageInfo _tmp21_;
	GeeArrayList* _tmp22_;
	CassettePageInfo _tmp23_;
#line 199 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/pager.vala"
	g_return_if_fail (page_info != NULL);
#line 200 "../src/pager.vala"
	_tmp0_ = self->priv->_custom_pages;
#line 200 "../src/pager.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 200 "../src/pager.vala"
	_tmp2_ = _tmp1_;
#line 200 "../src/pager.vala"
	if (_tmp2_ == 6) {
#line 1740 "pager.c"
		CassetteMainWindow* _tmp3_;
#line 201 "../src/pager.vala"
		_tmp3_ = self->priv->_window;
#line 201 "../src/pager.vala"
		cassette_main_window_show_message (_tmp3_, _ ("Reached max page count"));
#line 202 "../src/pager.vala"
		return;
#line 1748 "pager.c"
	}
	{
		GeeArrayList* _pg_i_list = NULL;
		GeeArrayList* _tmp4_;
		gint _pg_i_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _pg_i_index = 0;
#line 205 "../src/pager.vala"
		_tmp4_ = self->priv->_custom_pages;
#line 205 "../src/pager.vala"
		_pg_i_list = _tmp4_;
#line 205 "../src/pager.vala"
		_tmp5_ = _pg_i_list;
#line 205 "../src/pager.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 205 "../src/pager.vala"
		_tmp7_ = _tmp6_;
#line 205 "../src/pager.vala"
		_pg_i_size = _tmp7_;
#line 205 "../src/pager.vala"
		_pg_i_index = -1;
#line 205 "../src/pager.vala"
		while (TRUE) {
#line 1774 "pager.c"
			gint _tmp8_;
			gint _tmp9_;
			CassettePageInfo* pg_i = NULL;
			GeeArrayList* _tmp10_;
			gpointer _tmp11_;
			CassettePageInfo* _tmp12_;
			const gchar* _tmp13_;
			CassettePageInfo _tmp14_;
			const gchar* _tmp15_;
#line 205 "../src/pager.vala"
			_pg_i_index = _pg_i_index + 1;
#line 205 "../src/pager.vala"
			_tmp8_ = _pg_i_index;
#line 205 "../src/pager.vala"
			_tmp9_ = _pg_i_size;
#line 205 "../src/pager.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 205 "../src/pager.vala"
				break;
#line 1794 "pager.c"
			}
#line 205 "../src/pager.vala"
			_tmp10_ = _pg_i_list;
#line 205 "../src/pager.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _pg_i_index);
#line 205 "../src/pager.vala"
			pg_i = (CassettePageInfo*) _tmp11_;
#line 206 "../src/pager.vala"
			_tmp12_ = pg_i;
#line 206 "../src/pager.vala"
			_tmp13_ = (*_tmp12_).id;
#line 206 "../src/pager.vala"
			_tmp14_ = *page_info;
#line 206 "../src/pager.vala"
			_tmp15_ = _tmp14_.id;
#line 206 "../src/pager.vala"
			if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 1812 "pager.c"
				CassetteMainWindow* _tmp16_;
				CassettePageInfo _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 207 "../src/pager.vala"
				_tmp16_ = self->priv->_window;
#line 207 "../src/pager.vala"
				_tmp17_ = *page_info;
#line 207 "../src/pager.vala"
				_tmp18_ = _tmp17_.title;
#line 207 "../src/pager.vala"
				_tmp19_ = g_strdup_printf (_ ("Page '%s' already added"), _tmp18_);
#line 207 "../src/pager.vala"
				_tmp20_ = _tmp19_;
#line 207 "../src/pager.vala"
				cassette_main_window_show_message (_tmp16_, _tmp20_);
#line 207 "../src/pager.vala"
				_g_free0 (_tmp20_);
#line 208 "../src/pager.vala"
				_cassette_page_info_free0 (pg_i);
#line 208 "../src/pager.vala"
				return;
#line 1836 "pager.c"
			}
#line 205 "../src/pager.vala"
			_cassette_page_info_free0 (pg_i);
#line 1840 "pager.c"
		}
	}
#line 212 "../src/pager.vala"
	_tmp21_ = *page_info;
#line 212 "../src/pager.vala"
	cassette_pager_add_page (self, &_tmp21_);
#line 213 "../src/pager.vala"
	_tmp22_ = self->priv->_custom_pages;
#line 213 "../src/pager.vala"
	_tmp23_ = *page_info;
#line 213 "../src/pager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, &_tmp23_);
#line 215 "../src/pager.vala"
	cassette_pager_save_pages (self);
#line 1855 "pager.c"
}

void
cassette_pager_load_pages (CassettePager* self,
                           CassettePagesType* pages_type_if_failed)
{
#line 218 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/pager.vala"
	cassette_pager_clear_pages (self);
#line 226 "../src/pager.vala"
	if (pages_type_if_failed != NULL) {
#line 1868 "pager.c"
		CassetteClientCachierStorager* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
#line 227 "../src/pager.vala"
		_tmp0_ = cassette_storager;
#line 227 "../src/pager.vala"
		_tmp1_ = cassette_client_cachier_storager_get_settings (_tmp0_);
#line 227 "../src/pager.vala"
		_tmp2_ = _tmp1_;
#line 227 "../src/pager.vala"
		if (!g_settings_get_boolean (_tmp2_, "default-pages-set")) {
#line 1880 "pager.c"
			CassetteClientCachierStorager* _tmp3_;
			GSettings* _tmp4_;
			GSettings* _tmp5_;
#line 228 "../src/pager.vala"
			switch (*pages_type_if_failed) {
#line 228 "../src/pager.vala"
				case CASSETTE_PAGES_TYPE_ONLINE:
#line 1888 "pager.c"
				{
#line 230 "../src/pager.vala"
					cassette_pager_set_online_default_pages (self);
#line 231 "../src/pager.vala"
					break;
#line 1894 "pager.c"
				}
#line 228 "../src/pager.vala"
				case CASSETTE_PAGES_TYPE_LOCAL:
#line 1898 "pager.c"
				{
#line 233 "../src/pager.vala"
					cassette_pager_set_local_default_pages (self);
#line 234 "../src/pager.vala"
					break;
#line 1904 "pager.c"
				}
				default:
				{
#line 236 "../src/pager.vala"
					g_assert_not_reached ();
#line 1910 "pager.c"
				}
			}
#line 238 "../src/pager.vala"
			_tmp3_ = cassette_storager;
#line 238 "../src/pager.vala"
			_tmp4_ = cassette_client_cachier_storager_get_settings (_tmp3_);
#line 238 "../src/pager.vala"
			_tmp5_ = _tmp4_;
#line 238 "../src/pager.vala"
			g_settings_set_boolean (_tmp5_, "default-pages-set", TRUE);
#line 1921 "pager.c"
		}
	}
#line 242 "../src/pager.vala"
	cassette_pager_load_static_pages (self);
#line 243 "../src/pager.vala"
	cassette_pager_load_custom_pages (self);
#line 1928 "pager.c"
}

static void
cassette_pager_set_online_default_pages (CassettePager* self)
{
	CassetteClientCachierStorager* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	CassetteClientCachierStorager* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	CassetteClientCachierStorager* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
#line 246 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/pager.vala"
	_tmp0_ = cassette_storager;
#line 247 "../src/pager.vala"
	_tmp1_ = cassette_client_cachier_storager_get_settings (_tmp0_);
#line 247 "../src/pager.vala"
	_tmp2_ = _tmp1_;
#line 247 "../src/pager.vala"
	g_settings_set_boolean (_tmp2_, "show-main", TRUE);
#line 248 "../src/pager.vala"
	_tmp3_ = cassette_storager;
#line 248 "../src/pager.vala"
	_tmp4_ = cassette_client_cachier_storager_get_settings (_tmp3_);
#line 248 "../src/pager.vala"
	_tmp5_ = _tmp4_;
#line 248 "../src/pager.vala"
	g_settings_set_boolean (_tmp5_, "show-liked", TRUE);
#line 249 "../src/pager.vala"
	_tmp6_ = cassette_storager;
#line 249 "../src/pager.vala"
	_tmp7_ = cassette_client_cachier_storager_get_settings (_tmp6_);
#line 249 "../src/pager.vala"
	_tmp8_ = _tmp7_;
#line 249 "../src/pager.vala"
	g_settings_set_boolean (_tmp8_, "show-playlists", TRUE);
#line 1969 "pager.c"
}

static void
cassette_pager_set_local_default_pages (CassettePager* self)
{
#line 252 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/pager.vala"
	g_assert_not_reached ();
#line 1979 "pager.c"
}

static void
cassette_pager_load_static_pages (CassettePager* self)
{
	CassetteClientCachierStorager* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	CassetteClientCachierStorager* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	CassetteClientCachierStorager* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
#line 256 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/pager.vala"
	_tmp0_ = cassette_storager;
#line 257 "../src/pager.vala"
	_tmp1_ = cassette_client_cachier_storager_get_settings (_tmp0_);
#line 257 "../src/pager.vala"
	_tmp2_ = _tmp1_;
#line 257 "../src/pager.vala"
	if (g_settings_get_boolean (_tmp2_, "show-main")) {
#line 2004 "pager.c"
		const gchar* _tmp3_;
		CassettePageInfo _tmp4_ = {0};
#line 258 "../src/pager.vala"
		_tmp3_ = g_type_name (CASSETTE_TYPE_MAIN_VIEW);
#line 258 "../src/pager.vala"
		_g_free0 (_tmp4_.id);
#line 258 "../src/pager.vala"
		_tmp4_.id = "main";
#line 258 "../src/pager.vala"
		_g_free0 (_tmp4_.title);
#line 258 "../src/pager.vala"
		_tmp4_.title = _ ("Main");
#line 258 "../src/pager.vala"
		_g_free0 (_tmp4_.icon_name);
#line 258 "../src/pager.vala"
		_tmp4_.icon_name = "go-home-symbolic";
#line 258 "../src/pager.vala"
		_g_free0 (_tmp4_.view_type_name);
#line 258 "../src/pager.vala"
		_tmp4_.view_type_name = _tmp3_;
#line 258 "../src/pager.vala"
		cassette_pager_add_page (self, &_tmp4_);
#line 2027 "pager.c"
	}
#line 266 "../src/pager.vala"
	_tmp5_ = cassette_storager;
#line 266 "../src/pager.vala"
	_tmp6_ = cassette_client_cachier_storager_get_settings (_tmp5_);
#line 266 "../src/pager.vala"
	_tmp7_ = _tmp6_;
#line 266 "../src/pager.vala"
	if (g_settings_get_boolean (_tmp7_, "show-liked")) {
#line 2037 "pager.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		CassettePageInfo _tmp12_ = {0};
#line 267 "../src/pager.vala"
		_tmp8_ = g_type_name (CASSETTE_TYPE_PLAYLIST_VIEW);
#line 267 "../src/pager.vala"
		_tmp9_ = g_strdup ("3");
#line 267 "../src/pager.vala"
		_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 267 "../src/pager.vala"
		_tmp10_[0] = NULL;
#line 267 "../src/pager.vala"
		_tmp10_[1] = _tmp9_;
#line 267 "../src/pager.vala"
		_tmp11_ = _tmp10_;
#line 267 "../src/pager.vala"
		_tmp11__length1 = 2;
#line 267 "../src/pager.vala"
		_g_free0 (_tmp12_.id);
#line 267 "../src/pager.vala"
		_tmp12_.id = "liked";
#line 267 "../src/pager.vala"
		_g_free0 (_tmp12_.title);
#line 267 "../src/pager.vala"
		_tmp12_.title = _ ("Liked");
#line 267 "../src/pager.vala"
		_g_free0 (_tmp12_.icon_name);
#line 267 "../src/pager.vala"
		_tmp12_.icon_name = "emblem-favorite-symbolic";
#line 267 "../src/pager.vala"
		_g_free0 (_tmp12_.view_type_name);
#line 267 "../src/pager.vala"
		_tmp12_.view_type_name = _tmp8_;
#line 267 "../src/pager.vala"
		_tmp12_.args = (_vala_array_free (_tmp12_.args, _tmp12_.args_length1, (GDestroyNotify) g_free), NULL);
#line 267 "../src/pager.vala"
		_tmp12_.args = _tmp11_;
#line 267 "../src/pager.vala"
		_tmp12_.args_length1 = 2;
#line 267 "../src/pager.vala"
		cassette_pager_add_page (self, &_tmp12_);
#line 267 "../src/pager.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 2084 "pager.c"
	}
#line 276 "../src/pager.vala"
	_tmp13_ = cassette_storager;
#line 276 "../src/pager.vala"
	_tmp14_ = cassette_client_cachier_storager_get_settings (_tmp13_);
#line 276 "../src/pager.vala"
	_tmp15_ = _tmp14_;
#line 276 "../src/pager.vala"
	if (g_settings_get_boolean (_tmp15_, "show-playlists")) {
#line 2094 "pager.c"
		const gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gint _tmp18__length1;
		CassettePageInfo _tmp19_ = {0};
#line 277 "../src/pager.vala"
		_tmp16_ = g_type_name (CASSETTE_TYPE_PLAYLISTS_VIEW);
#line 277 "../src/pager.vala"
		_tmp17_ = g_new0 (gchar*, 1 + 1);
#line 277 "../src/pager.vala"
		_tmp17_[0] = NULL;
#line 277 "../src/pager.vala"
		_tmp18_ = _tmp17_;
#line 277 "../src/pager.vala"
		_tmp18__length1 = 1;
#line 277 "../src/pager.vala"
		_g_free0 (_tmp19_.id);
#line 277 "../src/pager.vala"
		_tmp19_.id = "playlists";
#line 277 "../src/pager.vala"
		_g_free0 (_tmp19_.title);
#line 277 "../src/pager.vala"
		_tmp19_.title = _ ("Playlists");
#line 277 "../src/pager.vala"
		_g_free0 (_tmp19_.icon_name);
#line 277 "../src/pager.vala"
		_tmp19_.icon_name = "view-list-symbolic";
#line 277 "../src/pager.vala"
		_g_free0 (_tmp19_.view_type_name);
#line 277 "../src/pager.vala"
		_tmp19_.view_type_name = _tmp16_;
#line 277 "../src/pager.vala"
		_tmp19_.args = (_vala_array_free (_tmp19_.args, _tmp19_.args_length1, (GDestroyNotify) g_free), NULL);
#line 277 "../src/pager.vala"
		_tmp19_.args = _tmp18_;
#line 277 "../src/pager.vala"
		_tmp19_.args_length1 = 1;
#line 277 "../src/pager.vala"
		cassette_pager_add_page (self, &_tmp19_);
#line 277 "../src/pager.vala"
		_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 2136 "pager.c"
	}
}

static void
cassette_pager_load_custom_pages (CassettePager* self)
{
	GError* _inner_error0_ = NULL;
#line 287 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 2146 "pager.c"
	{
		GFile* _tmp0_;
		guint8* content = NULL;
		gint content_length1 = 0;
		gint _content_size_ = 0;
		GFile* _tmp1_;
		guint8* _tmp2_ = NULL;
		gsize _tmp3_ = 0;
		gchar* content_str = NULL;
		guint8* _tmp4_;
		gint _tmp4__length1;
		gsize _tmp5_ = 0;
		guchar* _tmp6_;
		gchar** contents = NULL;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint contents_length1;
		gint _contents_size_;
#line 289 "../src/pager.vala"
		_tmp0_ = self->priv->pages_file;
#line 289 "../src/pager.vala"
		if (!g_file_query_exists (_tmp0_, NULL)) {
#line 290 "../src/pager.vala"
			return;
#line 2172 "pager.c"
		}
#line 294 "../src/pager.vala"
		_tmp1_ = self->priv->pages_file;
#line 294 "../src/pager.vala"
		g_file_load_contents (_tmp1_, NULL, &_tmp2_, &_tmp3_, NULL, &_inner_error0_);
#line 294 "../src/pager.vala"
		content = (g_free (content), NULL);
#line 294 "../src/pager.vala"
		content = _tmp2_;
#line 294 "../src/pager.vala"
		content_length1 = _tmp3_;
#line 294 "../src/pager.vala"
		_content_size_ = content_length1;
#line 294 "../src/pager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "../src/pager.vala"
			content = (g_free (content), NULL);
#line 2190 "pager.c"
			goto __catch0_g_error;
		}
#line 295 "../src/pager.vala"
		_tmp4_ = content;
#line 295 "../src/pager.vala"
		_tmp4__length1 = content_length1;
#line 295 "../src/pager.vala"
		_tmp6_ = g_base64_decode ((const gchar*) _tmp4_, &_tmp5_);
#line 295 "../src/pager.vala"
		content_str = (gchar*) _tmp6_;
#line 297 "../src/pager.vala"
		_tmp7_ = content_str;
#line 297 "../src/pager.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, CASSETTE_PAGER_PAGES_DELIMETER, 0);
#line 297 "../src/pager.vala"
		contents = _tmp9_;
#line 297 "../src/pager.vala"
		contents_length1 = _vala_array_length (_tmp8_);
#line 297 "../src/pager.vala"
		_contents_size_ = contents_length1;
#line 2211 "pager.c"
		{
			gint i = 0;
#line 299 "../src/pager.vala"
			i = 0;
#line 2216 "pager.c"
			{
				gboolean _tmp10_ = FALSE;
#line 299 "../src/pager.vala"
				_tmp10_ = TRUE;
#line 299 "../src/pager.vala"
				while (TRUE) {
#line 2223 "pager.c"
					gchar** _tmp12_;
					gint _tmp12__length1;
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					CassettePageInfo _tmp15_ = {0};
					CassettePageInfo _tmp16_;
#line 299 "../src/pager.vala"
					if (!_tmp10_) {
#line 2233 "pager.c"
						gint _tmp11_;
#line 299 "../src/pager.vala"
						_tmp11_ = i;
#line 299 "../src/pager.vala"
						i = _tmp11_ + 1;
#line 2239 "pager.c"
					}
#line 299 "../src/pager.vala"
					_tmp10_ = FALSE;
#line 299 "../src/pager.vala"
					_tmp12_ = contents;
#line 299 "../src/pager.vala"
					_tmp12__length1 = contents_length1;
#line 299 "../src/pager.vala"
					if (!(i < _tmp12__length1)) {
#line 299 "../src/pager.vala"
						break;
#line 2251 "pager.c"
					}
#line 300 "../src/pager.vala"
					_tmp13_ = contents;
#line 300 "../src/pager.vala"
					_tmp13__length1 = contents_length1;
#line 300 "../src/pager.vala"
					_tmp14_ = _tmp13_[i];
#line 300 "../src/pager.vala"
					cassette_page_info_from_string (_tmp14_, &_tmp15_);
#line 300 "../src/pager.vala"
					_tmp16_ = _tmp15_;
#line 300 "../src/pager.vala"
					cassette_pager_add_custom_page (self, &_tmp16_);
#line 300 "../src/pager.vala"
					cassette_page_info_destroy (&_tmp16_);
#line 2267 "pager.c"
				}
			}
		}
#line 288 "../src/pager.vala"
		contents = (_vala_array_free (contents, contents_length1, (GDestroyNotify) g_free), NULL);
#line 288 "../src/pager.vala"
		_g_free0 (content_str);
#line 288 "../src/pager.vala"
		content = (g_free (content), NULL);
#line 2277 "pager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 288 "../src/pager.vala"
		e = _inner_error0_;
#line 288 "../src/pager.vala"
		_inner_error0_ = NULL;
#line 304 "../src/pager.vala"
		_tmp17_ = e;
#line 304 "../src/pager.vala"
		_tmp18_ = _tmp17_->message;
#line 304 "../src/pager.vala"
		_tmp19_ = g_strdup_printf (_ ("Can't read pages file. Messsage: %s"), _tmp18_);
#line 304 "../src/pager.vala"
		_tmp20_ = _tmp19_;
#line 304 "../src/pager.vala"
		cassette_client_logger_warning (_tmp20_);
#line 304 "../src/pager.vala"
		_g_free0 (_tmp20_);
#line 288 "../src/pager.vala"
		_g_error_free0 (e);
#line 2305 "pager.c"
	}
	__finally0:
#line 288 "../src/pager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/pager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "../src/pager.vala"
		g_clear_error (&_inner_error0_);
#line 288 "../src/pager.vala"
		return;
#line 2316 "pager.c"
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1566 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1567 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1567 "glib-2.0.vapi"
	res_length1 = -1;
#line 1567 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1568 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1568 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1568 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1569 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1569 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1569 "glib-2.0.vapi"
	if (result_length1) {
#line 1569 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 2354 "pager.c"
	}
#line 1569 "glib-2.0.vapi"
	result = _tmp2_;
#line 1569 "glib-2.0.vapi"
	return result;
#line 2360 "pager.c"
}

static void
cassette_pager_save_pages (CassettePager* self)
{
	gchar** content = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar** _tmp3_;
	gint content_length1;
	gint _content_size_;
	GError* _inner_error0_ = NULL;
#line 308 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/pager.vala"
	_tmp0_ = self->priv->_custom_pages;
#line 309 "../src/pager.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 309 "../src/pager.vala"
	_tmp2_ = _tmp1_;
#line 309 "../src/pager.vala"
	_tmp3_ = g_new0 (gchar*, _tmp2_ + 1);
#line 309 "../src/pager.vala"
	content = _tmp3_;
#line 309 "../src/pager.vala"
	content_length1 = _tmp2_;
#line 309 "../src/pager.vala"
	_content_size_ = content_length1;
#line 2390 "pager.c"
	{
		gint i = 0;
#line 311 "../src/pager.vala"
		i = 0;
#line 2395 "pager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 311 "../src/pager.vala"
			_tmp4_ = TRUE;
#line 311 "../src/pager.vala"
			while (TRUE) {
#line 2402 "pager.c"
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** _tmp7_;
				gint _tmp7__length1;
				GeeArrayList* _tmp8_;
				gpointer _tmp9_;
				CassettePageInfo* _tmp10_;
				CassettePageInfo _tmp11_;
				gchar* _tmp12_;
#line 311 "../src/pager.vala"
				if (!_tmp4_) {
#line 2414 "pager.c"
					gint _tmp5_;
#line 311 "../src/pager.vala"
					_tmp5_ = i;
#line 311 "../src/pager.vala"
					i = _tmp5_ + 1;
#line 2420 "pager.c"
				}
#line 311 "../src/pager.vala"
				_tmp4_ = FALSE;
#line 311 "../src/pager.vala"
				_tmp6_ = content;
#line 311 "../src/pager.vala"
				_tmp6__length1 = content_length1;
#line 311 "../src/pager.vala"
				if (!(i < _tmp6__length1)) {
#line 311 "../src/pager.vala"
					break;
#line 2432 "pager.c"
				}
#line 312 "../src/pager.vala"
				_tmp7_ = content;
#line 312 "../src/pager.vala"
				_tmp7__length1 = content_length1;
#line 312 "../src/pager.vala"
				_tmp8_ = self->priv->_custom_pages;
#line 312 "../src/pager.vala"
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, i);
#line 312 "../src/pager.vala"
				_tmp10_ = (CassettePageInfo*) _tmp9_;
#line 312 "../src/pager.vala"
				_tmp11_ = *_tmp10_;
#line 312 "../src/pager.vala"
				_tmp12_ = cassette_page_info_to_string (&_tmp11_);
#line 312 "../src/pager.vala"
				_g_free0 (_tmp7_[i]);
#line 312 "../src/pager.vala"
				_tmp7_[i] = _tmp12_;
#line 312 "../src/pager.vala"
				_cassette_page_info_free0 (_tmp10_);
#line 2454 "pager.c"
			}
		}
	}
	{
		GFile* _tmp13_;
		gchar* content_str = NULL;
		gchar** _tmp17_;
		gint _tmp17__length1;
		gchar* _tmp18_;
		gchar* _tmp19_;
		guint8* _tmp20_;
		gint _tmp20__length1;
		gint _tmp21_ = 0;
		guint8* _tmp22_;
		gint _tmp22__length1;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 316 "../src/pager.vala"
		_tmp13_ = self->priv->pages_file;
#line 316 "../src/pager.vala"
		if (!g_file_query_exists (_tmp13_, NULL)) {
#line 2482 "pager.c"
			GFile* _tmp14_;
			GFileOutputStream* _tmp15_;
			GFileOutputStream* _tmp16_;
#line 317 "../src/pager.vala"
			_tmp14_ = self->priv->pages_file;
#line 317 "../src/pager.vala"
			_tmp15_ = g_file_create (_tmp14_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 317 "../src/pager.vala"
			_tmp16_ = _tmp15_;
#line 317 "../src/pager.vala"
			_g_object_unref0 (_tmp16_);
#line 317 "../src/pager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2496 "pager.c"
				goto __catch0_g_error;
			}
		}
#line 320 "../src/pager.vala"
		_tmp17_ = content;
#line 320 "../src/pager.vala"
		_tmp17__length1 = content_length1;
#line 320 "../src/pager.vala"
		_tmp18_ = _vala_g_strjoinv (CASSETTE_PAGER_PAGES_DELIMETER, _tmp17_, (gint) _tmp17__length1);
#line 320 "../src/pager.vala"
		_tmp19_ = _tmp18_;
#line 320 "../src/pager.vala"
		_tmp20_ = string_get_data (_tmp19_, &_tmp21_);
#line 320 "../src/pager.vala"
		_tmp20__length1 = _tmp21_;
#line 320 "../src/pager.vala"
		_tmp22_ = _tmp20_;
#line 320 "../src/pager.vala"
		_tmp22__length1 = _tmp20__length1;
#line 320 "../src/pager.vala"
		_tmp23_ = g_base64_encode (_tmp22_, (gint) _tmp22__length1);
#line 320 "../src/pager.vala"
		_tmp24_ = _tmp23_;
#line 320 "../src/pager.vala"
		_g_free0 (_tmp19_);
#line 320 "../src/pager.vala"
		content_str = _tmp24_;
#line 321 "../src/pager.vala"
		_tmp25_ = self->priv->pages_file;
#line 321 "../src/pager.vala"
		_tmp26_ = g_file_peek_path (_tmp25_);
#line 321 "../src/pager.vala"
		_tmp27_ = content_str;
#line 321 "../src/pager.vala"
		_tmp28_ = content_str;
#line 321 "../src/pager.vala"
		_tmp29_ = strlen (_tmp28_);
#line 321 "../src/pager.vala"
		_tmp30_ = _tmp29_;
#line 321 "../src/pager.vala"
		g_file_set_contents (_tmp26_, _tmp27_, (gssize) _tmp30_, &_inner_error0_);
#line 321 "../src/pager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "../src/pager.vala"
			_g_free0 (content_str);
#line 2542 "pager.c"
			goto __catch0_g_error;
		}
#line 315 "../src/pager.vala"
		_g_free0 (content_str);
#line 2547 "pager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
#line 315 "../src/pager.vala"
		e = _inner_error0_;
#line 315 "../src/pager.vala"
		_inner_error0_ = NULL;
#line 324 "../src/pager.vala"
		_tmp31_ = e;
#line 324 "../src/pager.vala"
		_tmp32_ = _tmp31_->message;
#line 324 "../src/pager.vala"
		_tmp33_ = g_strdup_printf (_ ("Can't create pages file. Messsage: %s"), _tmp32_);
#line 324 "../src/pager.vala"
		_tmp34_ = _tmp33_;
#line 324 "../src/pager.vala"
		cassette_client_logger_warning (_tmp34_);
#line 324 "../src/pager.vala"
		_g_free0 (_tmp34_);
#line 315 "../src/pager.vala"
		_g_error_free0 (e);
#line 2575 "pager.c"
	}
	__finally0:
#line 315 "../src/pager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "../src/pager.vala"
		content = (_vala_array_free (content, content_length1, (GDestroyNotify) g_free), NULL);
#line 315 "../src/pager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 315 "../src/pager.vala"
		g_clear_error (&_inner_error0_);
#line 315 "../src/pager.vala"
		return;
#line 2588 "pager.c"
	}
#line 308 "../src/pager.vala"
	content = (_vala_array_free (content, content_length1, (GDestroyNotify) g_free), NULL);
#line 2592 "pager.c"
}

static void
cassette_pager_clear_pages (CassettePager* self)
{
	GeeArrayList* _tmp13_;
#line 328 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 2601 "pager.c"
	{
		GeeArrayList* _page_info_list = NULL;
		GeeArrayList* _tmp0_;
		gint _page_info_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _page_info_index = 0;
#line 329 "../src/pager.vala"
		_tmp0_ = self->priv->_custom_pages;
#line 329 "../src/pager.vala"
		_page_info_list = _tmp0_;
#line 329 "../src/pager.vala"
		_tmp1_ = _page_info_list;
#line 329 "../src/pager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 329 "../src/pager.vala"
		_tmp3_ = _tmp2_;
#line 329 "../src/pager.vala"
		_page_info_size = _tmp3_;
#line 329 "../src/pager.vala"
		_page_info_index = -1;
#line 329 "../src/pager.vala"
		while (TRUE) {
#line 2626 "pager.c"
			gint _tmp4_;
			gint _tmp5_;
			CassettePageInfo* page_info = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			AdwViewStack* _tmp8_;
			AdwViewStack* _tmp9_;
			CassettePageInfo* _tmp10_;
			const gchar* _tmp11_;
			GtkWidget* _tmp12_;
#line 329 "../src/pager.vala"
			_page_info_index = _page_info_index + 1;
#line 329 "../src/pager.vala"
			_tmp4_ = _page_info_index;
#line 329 "../src/pager.vala"
			_tmp5_ = _page_info_size;
#line 329 "../src/pager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 329 "../src/pager.vala"
				break;
#line 2647 "pager.c"
			}
#line 329 "../src/pager.vala"
			_tmp6_ = _page_info_list;
#line 329 "../src/pager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _page_info_index);
#line 329 "../src/pager.vala"
			page_info = (CassettePageInfo*) _tmp7_;
#line 330 "../src/pager.vala"
			_tmp8_ = self->priv->_stack;
#line 330 "../src/pager.vala"
			_tmp9_ = self->priv->_stack;
#line 330 "../src/pager.vala"
			_tmp10_ = page_info;
#line 330 "../src/pager.vala"
			_tmp11_ = (*_tmp10_).id;
#line 330 "../src/pager.vala"
			_tmp12_ = adw_view_stack_get_child_by_name (_tmp9_, _tmp11_);
#line 330 "../src/pager.vala"
			adw_view_stack_remove (_tmp8_, _tmp12_);
#line 329 "../src/pager.vala"
			_cassette_page_info_free0 (page_info);
#line 2669 "pager.c"
		}
	}
#line 333 "../src/pager.vala"
	_tmp13_ = self->priv->_custom_pages;
#line 333 "../src/pager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp13_);
#line 335 "../src/pager.vala"
	cassette_pager_clear_static_page (self, "main");
#line 336 "../src/pager.vala"
	cassette_pager_clear_static_page (self, "liked");
#line 337 "../src/pager.vala"
	cassette_pager_clear_static_page (self, "playlists");
#line 2682 "pager.c"
}

static void
cassette_pager_clear_page (CassettePager* self,
                           const gchar* page_id)
{
	AdwViewStack* _tmp0_;
	AdwViewStack* _tmp1_;
	GtkWidget* _tmp2_;
#line 340 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/pager.vala"
	g_return_if_fail (page_id != NULL);
#line 341 "../src/pager.vala"
	_tmp0_ = self->priv->_stack;
#line 341 "../src/pager.vala"
	_tmp1_ = self->priv->_stack;
#line 341 "../src/pager.vala"
	_tmp2_ = adw_view_stack_get_child_by_name (_tmp1_, page_id);
#line 341 "../src/pager.vala"
	adw_view_stack_remove (_tmp0_, _tmp2_);
#line 2704 "pager.c"
	{
		gint i = 0;
#line 343 "../src/pager.vala"
		i = 0;
#line 2709 "pager.c"
		{
			gboolean _tmp3_ = FALSE;
#line 343 "../src/pager.vala"
			_tmp3_ = TRUE;
#line 343 "../src/pager.vala"
			while (TRUE) {
#line 2716 "pager.c"
				GeeArrayList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				GeeArrayList* _tmp8_;
				gpointer _tmp9_;
				CassettePageInfo* _tmp10_;
				const gchar* _tmp11_;
				gboolean _tmp12_;
#line 343 "../src/pager.vala"
				if (!_tmp3_) {
#line 2727 "pager.c"
					gint _tmp4_;
#line 343 "../src/pager.vala"
					_tmp4_ = i;
#line 343 "../src/pager.vala"
					i = _tmp4_ + 1;
#line 2733 "pager.c"
				}
#line 343 "../src/pager.vala"
				_tmp3_ = FALSE;
#line 343 "../src/pager.vala"
				_tmp5_ = self->priv->_custom_pages;
#line 343 "../src/pager.vala"
				_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 343 "../src/pager.vala"
				_tmp7_ = _tmp6_;
#line 343 "../src/pager.vala"
				if (!(i < _tmp7_)) {
#line 343 "../src/pager.vala"
					break;
#line 2747 "pager.c"
				}
#line 344 "../src/pager.vala"
				_tmp8_ = self->priv->_custom_pages;
#line 344 "../src/pager.vala"
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, i);
#line 344 "../src/pager.vala"
				_tmp10_ = (CassettePageInfo*) _tmp9_;
#line 344 "../src/pager.vala"
				_tmp11_ = (*_tmp10_).id;
#line 344 "../src/pager.vala"
				_tmp12_ = g_strcmp0 (_tmp11_, page_id) == 0;
#line 344 "../src/pager.vala"
				_cassette_page_info_free0 (_tmp10_);
#line 344 "../src/pager.vala"
				if (_tmp12_) {
#line 2763 "pager.c"
					GeeArrayList* _tmp13_;
					gpointer _tmp14_;
					CassettePageInfo* _tmp15_;
#line 345 "../src/pager.vala"
					_tmp13_ = self->priv->_custom_pages;
#line 345 "../src/pager.vala"
					_tmp14_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp13_, i);
#line 345 "../src/pager.vala"
					_tmp15_ = (CassettePageInfo*) _tmp14_;
#line 345 "../src/pager.vala"
					_cassette_page_info_free0 (_tmp15_);
#line 346 "../src/pager.vala"
					break;
#line 2777 "pager.c"
				}
			}
		}
	}
}

static void
cassette_pager_clear_static_page (CassettePager* self,
                                  const gchar* page_id)
{
	AdwViewStack* _tmp0_;
	GtkWidget* _tmp1_;
#line 351 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/pager.vala"
	g_return_if_fail (page_id != NULL);
#line 352 "../src/pager.vala"
	_tmp0_ = self->priv->_stack;
#line 352 "../src/pager.vala"
	_tmp1_ = adw_view_stack_get_child_by_name (_tmp0_, page_id);
#line 352 "../src/pager.vala"
	if (_tmp1_ != NULL) {
#line 353 "../src/pager.vala"
		cassette_pager_clear_page (self, page_id);
#line 2802 "pager.c"
	}
}

void
cassette_pager_remove_page (CassettePager* self,
                            const gchar* page_id)
{
#line 357 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/pager.vala"
	g_return_if_fail (page_id != NULL);
#line 358 "../src/pager.vala"
	cassette_pager_clear_page (self, page_id);
#line 360 "../src/pager.vala"
	cassette_pager_save_pages (self);
#line 2818 "pager.c"
}

CassetteMainWindow*
cassette_pager_get_window (CassettePager* self)
{
	CassetteMainWindow* result;
	CassetteMainWindow* _tmp0_;
#line 86 "../src/pager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../src/pager.vala"
	_tmp0_ = self->priv->_window;
#line 86 "../src/pager.vala"
	result = _tmp0_;
#line 86 "../src/pager.vala"
	return result;
#line 2834 "pager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 86 "../src/pager.vala"
	return self ? g_object_ref (self) : NULL;
#line 2842 "pager.c"
}

void
cassette_pager_set_window (CassettePager* self,
                           CassetteMainWindow* value)
{
	CassetteMainWindow* old_value;
#line 86 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/pager.vala"
	old_value = cassette_pager_get_window (self);
#line 86 "../src/pager.vala"
	if (old_value != value) {
#line 2856 "pager.c"
		CassetteMainWindow* _tmp0_;
#line 86 "../src/pager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 86 "../src/pager.vala"
		_g_object_unref0 (self->priv->_window);
#line 86 "../src/pager.vala"
		self->priv->_window = _tmp0_;
#line 86 "../src/pager.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_pager_properties[CASSETTE_PAGER_WINDOW_PROPERTY]);
#line 2866 "pager.c"
	}
}

AdwViewStack*
cassette_pager_get_stack (CassettePager* self)
{
	AdwViewStack* result;
	AdwViewStack* _tmp0_;
#line 87 "../src/pager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/pager.vala"
	_tmp0_ = self->priv->_stack;
#line 87 "../src/pager.vala"
	result = _tmp0_;
#line 87 "../src/pager.vala"
	return result;
#line 2883 "pager.c"
}

void
cassette_pager_set_stack (CassettePager* self,
                          AdwViewStack* value)
{
	AdwViewStack* old_value;
#line 87 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/pager.vala"
	old_value = cassette_pager_get_stack (self);
#line 87 "../src/pager.vala"
	if (old_value != value) {
#line 2897 "pager.c"
		AdwViewStack* _tmp0_;
#line 87 "../src/pager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 87 "../src/pager.vala"
		_g_object_unref0 (self->priv->_stack);
#line 87 "../src/pager.vala"
		self->priv->_stack = _tmp0_;
#line 87 "../src/pager.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_pager_properties[CASSETTE_PAGER_STACK_PROPERTY]);
#line 2907 "pager.c"
	}
}

GeeArrayList*
cassette_pager_get_custom_pages (CassettePager* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 91 "../src/pager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../src/pager.vala"
	_tmp0_ = self->priv->_custom_pages;
#line 92 "../src/pager.vala"
	result = _tmp0_;
#line 92 "../src/pager.vala"
	return result;
#line 2924 "pager.c"
}

void
cassette_pager_set_custom_pages (CassettePager* self,
                                 GeeArrayList* value)
{
	GeeArrayList* _tmp0_;
#line 94 "../src/pager.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/pager.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 95 "../src/pager.vala"
	_g_object_unref0 (self->priv->_custom_pages);
#line 95 "../src/pager.vala"
	self->priv->_custom_pages = _tmp0_;
#line 97 "../src/pager.vala"
	cassette_pager_load_pages (self, NULL);
#line 94 "../src/pager.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_pager_properties[CASSETTE_PAGER_CUSTOM_PAGES_PROPERTY]);
#line 2944 "pager.c"
}

static void
_cassette_pager___lambda219_ (CassettePager* self,
                              const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 117 "../src/pager.vala"
	g_return_if_fail (key != NULL);
#line 119 "../src/pager.vala"
	if (g_strcmp0 (key, "show-main") == 0) {
#line 119 "../src/pager.vala"
		_tmp2_ = TRUE;
#line 2960 "pager.c"
	} else {
#line 120 "../src/pager.vala"
		_tmp2_ = g_strcmp0 (key, "show-liked") == 0;
#line 2964 "pager.c"
	}
#line 119 "../src/pager.vala"
	if (_tmp2_) {
#line 119 "../src/pager.vala"
		_tmp1_ = TRUE;
#line 2970 "pager.c"
	} else {
#line 121 "../src/pager.vala"
		_tmp1_ = g_strcmp0 (key, "show-playlists") == 0;
#line 2974 "pager.c"
	}
#line 119 "../src/pager.vala"
	if (_tmp1_) {
#line 2978 "pager.c"
		CassetteClientCachierStorager* _tmp3_;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
#line 122 "../src/pager.vala"
		_tmp3_ = cassette_storager;
#line 122 "../src/pager.vala"
		_tmp4_ = cassette_client_cachier_storager_get_settings (_tmp3_);
#line 122 "../src/pager.vala"
		_tmp5_ = _tmp4_;
#line 122 "../src/pager.vala"
		_tmp0_ = g_settings_get_boolean (_tmp5_, "default-pages-set");
#line 2990 "pager.c"
	} else {
#line 119 "../src/pager.vala"
		_tmp0_ = FALSE;
#line 2994 "pager.c"
	}
#line 118 "../src/pager.vala"
	if (_tmp0_) {
#line 124 "../src/pager.vala"
		cassette_pager_load_pages (self, NULL);
#line 3000 "pager.c"
	}
}

static void
__cassette_pager___lambda219__g_settings_changed (GSettings* _sender,
                                                  const gchar* key,
                                                  gpointer self)
{
#line 117 "../src/pager.vala"
	_cassette_pager___lambda219_ ((CassettePager*) self, key);
#line 3011 "pager.c"
}

static GObject *
cassette_pager_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CassettePager * self;
	CassetteClientCachierStorager* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GType _register_ = 0UL;
	CassetteClientCachierStorager* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
#line 107 "../src/pager.vala"
	parent_class = G_OBJECT_CLASS (cassette_pager_parent_class);
#line 107 "../src/pager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 107 "../src/pager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_TYPE_PAGER, CassettePager);
#line 108 "../src/pager.vala"
	_tmp0_ = cassette_storager;
#line 108 "../src/pager.vala"
	_tmp1_ = cassette_client_cachier_storager_get_cache_dir_file (_tmp0_);
#line 108 "../src/pager.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/pager.vala"
	_tmp3_ = g_file_peek_path (_tmp2_);
#line 108 "../src/pager.vala"
	_tmp4_ = g_file_new_build_filename (_tmp3_, "cassette.pages", NULL);
#line 108 "../src/pager.vala"
	_g_object_unref0 (self->priv->pages_file);
#line 108 "../src/pager.vala"
	self->priv->pages_file = _tmp4_;
#line 113 "../src/pager.vala"
	_register_ = CASSETTE_TYPE_PLAYLIST_VIEW;
#line 114 "../src/pager.vala"
	_register_ = CASSETTE_TYPE_PLAYLISTS_VIEW;
#line 115 "../src/pager.vala"
	_register_ = CASSETTE_TYPE_MAIN_VIEW;
#line 117 "../src/pager.vala"
	_tmp5_ = cassette_storager;
#line 117 "../src/pager.vala"
	_tmp6_ = cassette_client_cachier_storager_get_settings (_tmp5_);
#line 117 "../src/pager.vala"
	_tmp7_ = _tmp6_;
#line 117 "../src/pager.vala"
	g_signal_connect_object (_tmp7_, "changed", (GCallback) __cassette_pager___lambda219__g_settings_changed, self, 0);
#line 107 "../src/pager.vala"
	return obj;
#line 3067 "pager.c"
}

static void
cassette_pager_class_init (CassettePagerClass * klass,
                           gpointer klass_data)
{
#line 84 "../src/pager.vala"
	cassette_pager_parent_class = g_type_class_peek_parent (klass);
#line 84 "../src/pager.vala"
	g_type_class_adjust_private_offset (klass, &CassettePager_private_offset);
#line 84 "../src/pager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cassette_pager_get_property;
#line 84 "../src/pager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cassette_pager_set_property;
#line 84 "../src/pager.vala"
	G_OBJECT_CLASS (klass)->constructor = cassette_pager_constructor;
#line 84 "../src/pager.vala"
	G_OBJECT_CLASS (klass)->finalize = cassette_pager_finalize;
#line 84 "../src/pager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_PAGER_WINDOW_PROPERTY, cassette_pager_properties[CASSETTE_PAGER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", CASSETTE_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 84 "../src/pager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_PAGER_STACK_PROPERTY, cassette_pager_properties[CASSETTE_PAGER_STACK_PROPERTY] = g_param_spec_object ("stack", "stack", "stack", adw_view_stack_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 84 "../src/pager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_PAGER_CUSTOM_PAGES_PROPERTY, cassette_pager_properties[CASSETTE_PAGER_CUSTOM_PAGES_PROPERTY] = g_param_spec_object ("custom-pages", "custom-pages", "custom-pages", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3092 "pager.c"
}

static void
cassette_pager_instance_init (CassettePager * self,
                              gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 84 "../src/pager.vala"
	self->priv = cassette_pager_get_instance_private (self);
#line 89 "../src/pager.vala"
	_tmp0_ = gee_array_list_new (CASSETTE_TYPE_PAGE_INFO, (GBoxedCopyFunc) cassette_page_info_dup, (GDestroyNotify) cassette_page_info_free, NULL, NULL, NULL);
#line 89 "../src/pager.vala"
	self->priv->_custom_pages = _tmp0_;
#line 3106 "pager.c"
}

static void
cassette_pager_finalize (GObject * obj)
{
	CassettePager * self;
#line 84 "../src/pager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_TYPE_PAGER, CassettePager);
#line 86 "../src/pager.vala"
	_g_object_unref0 (self->priv->_window);
#line 87 "../src/pager.vala"
	_g_object_unref0 (self->priv->_stack);
#line 89 "../src/pager.vala"
	_g_object_unref0 (self->priv->_custom_pages);
#line 101 "../src/pager.vala"
	_g_object_unref0 (self->priv->pages_file);
#line 133 "../src/pager.vala"
	G_OBJECT_CLASS (cassette_pager_parent_class)->finalize (obj);
#line 3125 "pager.c"
}

 G_GNUC_NO_INLINE static GType
cassette_pager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CassettePagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_pager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassettePager), 0, (GInstanceInitFunc) cassette_pager_instance_init, NULL };
	GType cassette_pager_type_id;
	cassette_pager_type_id = g_type_register_static (G_TYPE_OBJECT, "CassettePager", &g_define_type_info, 0);
	CassettePager_private_offset = g_type_add_instance_private (cassette_pager_type_id, sizeof (CassettePagerPrivate));
	return cassette_pager_type_id;
}

GType
cassette_pager_get_type (void)
{
	static gsize cassette_pager_type_id__once = 0;
	if (g_once_init_enter (&cassette_pager_type_id__once)) {
		GType cassette_pager_type_id;
		cassette_pager_type_id = cassette_pager_get_type_once ();
		g_once_init_leave (&cassette_pager_type_id__once, cassette_pager_type_id);
	}
	return cassette_pager_type_id__once;
}

static void
_vala_cassette_pager_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	CassettePager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_PAGER, CassettePager);
#line 84 "../src/pager.vala"
	switch (property_id) {
#line 84 "../src/pager.vala"
		case CASSETTE_PAGER_WINDOW_PROPERTY:
#line 84 "../src/pager.vala"
		g_value_set_object (value, cassette_pager_get_window (self));
#line 84 "../src/pager.vala"
		break;
#line 84 "../src/pager.vala"
		case CASSETTE_PAGER_STACK_PROPERTY:
#line 84 "../src/pager.vala"
		g_value_set_object (value, cassette_pager_get_stack (self));
#line 84 "../src/pager.vala"
		break;
#line 84 "../src/pager.vala"
		case CASSETTE_PAGER_CUSTOM_PAGES_PROPERTY:
#line 84 "../src/pager.vala"
		g_value_set_object (value, cassette_pager_get_custom_pages (self));
#line 84 "../src/pager.vala"
		break;
#line 3178 "pager.c"
		default:
#line 84 "../src/pager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 84 "../src/pager.vala"
		break;
#line 3184 "pager.c"
	}
}

static void
_vala_cassette_pager_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	CassettePager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_PAGER, CassettePager);
#line 84 "../src/pager.vala"
	switch (property_id) {
#line 84 "../src/pager.vala"
		case CASSETTE_PAGER_WINDOW_PROPERTY:
#line 84 "../src/pager.vala"
		cassette_pager_set_window (self, g_value_get_object (value));
#line 84 "../src/pager.vala"
		break;
#line 84 "../src/pager.vala"
		case CASSETTE_PAGER_STACK_PROPERTY:
#line 84 "../src/pager.vala"
		cassette_pager_set_stack (self, g_value_get_object (value));
#line 84 "../src/pager.vala"
		break;
#line 84 "../src/pager.vala"
		case CASSETTE_PAGER_CUSTOM_PAGES_PROPERTY:
#line 84 "../src/pager.vala"
		cassette_pager_set_custom_pages (self, g_value_get_object (value));
#line 84 "../src/pager.vala"
		break;
#line 3216 "pager.c"
		default:
#line 84 "../src/pager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 84 "../src/pager.vala"
		break;
#line 3222 "pager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 129 "../src/pager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 3233 "pager.c"
		gssize i;
#line 129 "../src/pager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 129 "../src/pager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 129 "../src/pager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 3241 "pager.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 129 "../src/pager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 129 "../src/pager.vala"
	g_free (array);
#line 3256 "pager.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 129 "../src/pager.vala"
	if (array) {
#line 129 "../src/pager.vala"
		while (((gpointer*) array)[length]) {
#line 129 "../src/pager.vala"
			length++;
#line 3270 "pager.c"
		}
	}
#line 129 "../src/pager.vala"
	return length;
#line 3275 "pager.c"
}

